/**
 * 用于跑测试的工程
 * ebike相关类使用说明
 */

/**
 * 1. 引用xcdsutils
 */
const XCEBike = require('./../index.js');

/**
 * 2. 配置自己工程的数据库和Redis
 */
const gSequelize = require('./XCDBUtils').gSequelize;
const redis = require('./XCEBikeRedis').xcRedis;
const yuntu = require('./XCYuntuUtil').xcYuntu;

XCEBike.config(redis, gSequelize, yuntu);


/**
 * 3. 暴露需要的类，也可以直接暴露XCEBike
 * 
 */

module.exports = XCEBike;


//测试

(async() => {
  let json = {};
  let device = new XCEBike.XCEBikeDevice(json);
  json = {agentId: 2};
  let gFence = new XCEBike.XCEBikeGFence(json);

  let imei = '865067022403441';
  let longitude = '114.425';
  let latitude = '30.511';
  await device.update2Yuntu(imei, longitude, latitude);

  imei = '865067022403442';
  longitude = '115.425';
  latitude = '30.511';
  await device.update2Yuntu(imei, longitude, latitude);

  imei = '865067022403441';
  longitude = '116.425';
  latitude = '30.511';
  await device.update2Yuntu(imei, longitude, latitude);

  imei = '865067022403441';
  longitude = '117.425';
  latitude = '30.511';
  await device.update2Yuntu(imei, longitude, latitude);

  imei = '865067022403440';
  longitude = '117.425';
  latitude = '30.511';
  await device.update2Yuntu(imei, longitude, latitude);

  longitude = '114.525';
  latitude = '30.511';
  let datas = await device.searchFromYuntu(longitude, latitude, 3000);
  console.log('datas:', datas);

  longitude = '117.425';
  latitude = '30.511';
  datas = await device.searchFromYuntu(longitude, latitude, 3000);
  console.log('datas:', datas);

  // let gFenceType = 1;
  // let gFenceId = 1;
  // longitude = '114.525';
  // latitude = '30.511';
  // await gFence.update2Yuntu(gFenceType, gFenceId, longitude, latitude);

  // gFenceType = 1;
  // gFenceId = 3;
  // longitude = '114.625';
  // latitude = '30.511';
  // await gFence.update2Yuntu(gFenceType, gFenceId, longitude, latitude);

  // gFenceType = 2;
  // gFenceId = 1;
  // longitude = '114.725';
  // latitude = '30.711';
  // await gFence.update2Yuntu(gFenceType, gFenceId, longitude, latitude);

  // longitude = '114.525';
  // latitude = '30.611';
  // let datas = await gFence.searchFromYuntu(1 ,longitude, latitude, 3000);
  // console.log('datas:', datas);

  // longitude = '114.525';
  // latitude = '30.511';
  // datas = await gFence.searchFromYuntu(1 ,longitude, latitude, 3000);
  // console.log('datas:', datas);

  // ret = await redis.config('SET', 'notify-keyspace-events', 'Ex');
  // console.log('config result:', ret);

  // setTimeout(() => {

  //   (async() => {
  //     let usr = new XCEBike.XCEBikeUser('dhjek3r3ewr3');
  //     await usr.setBookingImei('865067022403441');
  //     console.log('booking imei:', await usr.getBookingImei());
  //     console.log('user state', await usr.getState());
  //     console.log('booking sum:', await XCEBike.XCEBikeUser.bookingUserCount(2));

  //   })()

  // }, 3000)

  // setTimeout(() => {
  //   (async() => {
  //     let usr = new XCEBike.XCEBikeUser('dhjek3r3ewr3');
  //     console.log('booking imei:', await usr.getBookingImei());
  //     console.log('booking sum:', await XCEBike.XCEBikeUser.bookingUserCount(2));

  //   })()
  // }, 9000);


  // let gfence = await XCEBike.XCEBikeGFence.instanceFromRedis(2, 1);
  // if (!gfence) {
  //   gfence = new XCEBike.XCEBikeGFence({
  //     type: XCEBike.XCEBikeGFence.GFENCE_TYPE.atService,
  //     agentId: 2,
  //     pointList: JSON.stringify([{
  //       lat: 1,
  //       lng: 1
  //     }, {
  //       lat: 2,
  //       lng: 2
  //     }]),
  //     gFenceId: 1
  //   })
  //   let ret = await gfence.save2Redis();
  //   console.log('save ret', ret);
  //   gfence = await XCEBike.XCEBikeGFence.instanceFromRedis(2, 1);
  // }

  // console.log('gFence:', gfence);

  // gfence.centerLat = 3;
  // gfence.centerLng = 4;
  // await gfence.save2Redis();

  // gfence = await XCEBike.XCEBikeGFence.instanceFromRedis(2, 1);

  // ret = await gfence.delFromRedis();

  // gfence = await XCEBike.XCEBikeGFence.instanceFromRedis(2, 1);

  // console.log('gFence:', gfence);

})();